Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 381801 - [science overlay] mask >sci-libs/blas-reference-20
Summary: [science overlay] mask >sci-libs/blas-reference-20
Status: RESOLVED FIXED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: Current packages (show other bugs)
Hardware: All Linux
: Normal normal (vote)
Assignee: Gentoo Science Related Packages
URL:
Whiteboard:
Keywords:
Depends on:
Blocks:
 
Reported: 2011-09-04 16:54 UTC by Markus Oehme
Modified: 2019-07-03 12:33 UTC (History)
0 users

See Also:
Package list:
Runtime testing required: ---


Attachments
emerge --info (info.txt,5.39 KB, text/plain)
2011-09-04 16:55 UTC, Markus Oehme
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Markus Oehme 2011-09-04 16:54:10 UTC
I've got virtual/blas-2.0 from the science-overlay installed. Unfortunately this does not seem to install one of the required dependencies. The dependencies are as follows. 

>=sci-libs/blas-reference-3.3
>=dev-cpp/eigen-3.0.1-r1
>=sci-libs/atlas-3.8.4[fortran]
sci-libs/openblas
>=sci-libs/acml-4.4
>=sci-libs/gotoblas2-1.13
>=sci-libs/mkl-10.3
!>sci-libs/blas-reference-20070225

From these I've only got dev-cpp/eigen-2.0.15 installed (which is pulled in by blenders dependency on dev-cpp/eigen:2). Doing a 'emerge virtual/blas' in various tries did never install anything from the list.

If I manually install blas-reference and then execute 'emerge --depclean' blas-reference is removed from the system.

I'm quite quizzed as to what's happening here, but I don't have a blas library on my system and thus several packages which have virtual/blas as a dependency fail to build. I'm inclined to take this as a bug in portage (of which I'm using 2.2.0_alpha52).

Reproducible: Always
Comment 1 Markus Oehme 2011-09-04 16:55:31 UTC
Created attachment 285533 [details]
emerge --info

My emerge --info, I'm using hardened ~amd64.
Comment 2 Rafał Mużyło 2011-09-04 19:32:45 UTC
This is might be a bit like bug 380549, but the original poster there never got to check which real package got installed.

So:
- check, if the installed virtual actually comes from science overlay
- check that virtual and find out which real package it pulls
- attach one of the build logs of a failing build after the virtual is installed
(IIRC, there might  also be a matter of 'eselect blas', if it's still eselected, as it once was)
Comment 3 Markus Oehme 2011-09-04 20:07:33 UTC
(In reply to comment #2)
> This is might be a bit like bug 380549, but the original poster there never got
> to check which real package got installed.
> 
> So:
> - check, if the installed virtual actually comes from science overlay

I checked in /var/db/pkg and it says 'repository == science'.

> - check that virtual and find out which real package it pulls

Here I'm at a loss. It seems, that the virtual does not pull any packages 'emerge -pve virtual/blas' wants to remerge just the virtual. (Whereas if I try 'emerge -pve virtual/cron' I get hundreds of dependencies.)

Is there any other way to check this?

> - attach one of the build logs of a failing build after the virtual is
> installed

Now this is a bit curious, I fiddled a bit with it and now I've got a file /usr/lib/libblas.so which is owned by sci-libs/lapack-reference-3.3.1-r1. So the build errors have vanished. But sci-libs/lapack-reference is not a valid dependency of virtual/blas, hence I'm a bit confused.

During the hunt of this error I tried to do a manual check with pkg-config, which returned
'Package blas was not found in the pkg-config search path.'

> (IIRC, there might  also be a matter of 'eselect blas', if it's still
> eselected, as it once was)

As this all seems a bit interrelated I will now report all the packages which have some influence on 'eselect (blas|cblas|lapack)' on my system. First the installed packages:
* sci-libs/lapack-reference-3.3.1-r1 from science overlay
* sci-libs/gsl-1.15-r1 from science overlay
* app-admin/eselect-1.2.16-r1 from science overlay
Now the packages which I do not have installed:
* app-admin/eselect-blas
* app-admin/eselect-cblas
* app-admin/eselect-lapack
And now the output of 'eselect (blas|cblas|lapack) list':

Available providers for blas:
  (none found)

Available providers for cblas:
  [1]   gsl *

Available providers for cblas:
  [1]   reference *

I hope this helps to clear this confusing bug.
Comment 4 Rafał Mużyło 2011-09-05 13:35:52 UTC
It seems there might be a problem in parsing the virtual.
More exactly, it seems that ">=sci-libs/blas-reference-3.3 !>sci-libs/blas-reference-20070225" is plain broken.

This is what I get while science overlay is installed:
emerge -1pv virtual/blas

These are the packages that would be merged, in order:

Calculating dependencies... done!
[ebuild  N     ] app-doc/blas-docs-3.2.0  3,445 kB [1]
[ebuild  N     ] virtual/blas-2.0  USE="doc" 0 kB [1]

Total: 2 packages (2 new), Size of downloads: 3,445 kB
Portage tree and overlays:
 [0] /usr/portage
 [1] /var/lib/layman/science

emerge -1pv virtual/blas '>=sci-libs/blas-reference-3.3'

These are the packages that would be merged, in order:

Calculating dependencies... done!
[ebuild  N     ] app-doc/blas-docs-3.2.0  3,445 kB [1]
[ebuild  N     ] virtual/fortran-0  USE="openmp" 0 kB [0]
[ebuild  N     ] sci-libs/blas-reference-20070226-r2  USE="doc" 0 kB [0]
[ebuild  N     ] virtual/blas-2.0  USE="doc" 0 kB [1]

Total: 4 packages (4 new), Size of downloads: 3,445 kB
Portage tree and overlays:
 [0] /usr/portage
 [1] /var/lib/layman/science

emerge -1pv virtual/blas =sci-libs/blas-reference-3.3.1-r1

These are the packages that would be merged, in order:

Calculating dependencies... done!
[ebuild  N     ] app-doc/blas-docs-3.2.0  3,445 kB [1]
[ebuild  N     ] virtual/fortran-0  USE="openmp" 0 kB [0]
[ebuild     U  ] app-admin/eselect-1.2.16-r1 [1.2.15] USE="bash-completion doc" 166 kB [0=>1]
[ebuild  N     ] sci-libs/blas-reference-3.3.1-r1  USE="-static-libs -test" 4,830 kB [1]
[uninstall     ] app-admin/eselect-blas-0.1  [?]
[blocks b      ] app-admin/eselect-blas ("app-admin/eselect-blas" is blocking sci-libs/blas-reference-3.3.1-r1)
[uninstall     ] app-admin/eselect-cblas-0.1  [?]
[blocks b      ] app-admin/eselect-cblas ("app-admin/eselect-cblas" is blocking sci-libs/blas-reference-3.3.1-r1)
[ebuild  N     ] virtual/blas-2.0  USE="doc" 0 kB [1]

Total: 5 packages (1 upgrade, 4 new, 2 uninstalls), Size of downloads: 8,440 kB
Conflict: 2 blocks
Portage tree and overlays:
 [0] /usr/portage
 [1] /var/lib/layman/science
Comment 5 Sébastien Fabbro (RETIRED) gentoo-dev 2011-09-06 18:19:40 UTC
You have to mask >sci-libs/blas-reference-20 if you want to use the new blas stuff. We can not cross mask it in different overlays, and given the tree one is stable, we won't mask it until the new blas stuff is working.
Thanks.
Comment 6 Markus Oehme 2014-02-07 19:11:07 UTC
Taking a look at my bug queue, I want to respond here with newer insights: This may be best addressed by better documentation. I wrote something at [1], which may be useful.

[1] https://wiki.gentoo.org/wiki/User_talk:Houseofsuns#Migration_to_science_overlay_from_main_tree
Comment 7 Larry the Git Cow gentoo-dev 2019-06-26 06:06:55 UTC
The bug has been closed via the following commit(s):

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=5f8a985b71b033d7a7c4d252c00dd83669ee5913

commit 5f8a985b71b033d7a7c4d252c00dd83669ee5913
Author:     Mo Zhou <cdluminate@gmail.com>
AuthorDate: 2019-06-26 02:27:40 +0000
Commit:     Benda Xu <heroxbd@gentoo.org>
CommitDate: 2019-06-26 06:06:09 +0000

    virtual/{blas,cblas,lapack,lapacke}: add/update virtual packages.
    
      These virtual packages are used by the BLAS/LAPACK runtime switching
      mechanism.
    
      Drop old EAPI=5 ebuilds.
    
    Closes: https://github.com/gentoo/gentoo/pull/12323
    Closes: https://bugs.gentoo.org/373613
    Closes: https://bugs.gentoo.org/669644
    Closes: https://bugs.gentoo.org/564546
    Closes: https://bugs.gentoo.org/565776
    Closes: https://bugs.gentoo.org/646316
    Closes: https://bugs.gentoo.org/563674
    Closes: https://bugs.gentoo.org/659014
    Closes: https://bugs.gentoo.org/659264
    Closes: https://bugs.gentoo.org/657984
    Closes: https://bugs.gentoo.org/381801
    Closes: https://bugs.gentoo.org/646316
    Closes: https://bugs.gentoo.org/565776
    Closes: https://bugs.gentoo.org/498490
    
    Signed-off-by: Mo Zhou <cdluminate@gmail.com>
    Signed-off-by: Benda Xu <heroxbd@gentoo.org>

 virtual/blas/blas-1.0.ebuild       | 14 --------------
 virtual/blas/blas-3.8.ebuild       | 14 ++++++++++++++
 virtual/blas/metadata.xml          | 10 +++++++---
 virtual/cblas/cblas-1.0.ebuild     | 14 --------------
 virtual/cblas/cblas-3.8.ebuild     | 14 ++++++++++++++
 virtual/cblas/metadata.xml         | 10 +++++++---
 virtual/lapack/lapack-3.0.ebuild   | 13 -------------
 virtual/lapack/lapack-3.1.ebuild   | 13 -------------
 virtual/lapack/lapack-3.8.ebuild   | 14 ++++++++++++++
 virtual/lapack/metadata.xml        | 10 +++++++---
 virtual/lapacke/lapacke-3.8.ebuild | 14 ++++++++++++++
 virtual/lapacke/metadata.xml       | 16 ++++++++++++++++
 12 files changed, 93 insertions(+), 63 deletions(-)
Comment 8 Larry the Git Cow gentoo-dev 2019-07-03 12:33:53 UTC
The bug has been closed via the following commit(s):

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=0721aba4db4bc8ce37d11eab06ff528f31e4ce9f

commit 0721aba4db4bc8ce37d11eab06ff528f31e4ce9f
Author:     Benda Xu <heroxbd@gentoo.org>
AuthorDate: 2019-06-27 05:41:31 +0000
Commit:     Benda Xu <heroxbd@gentoo.org>
CommitDate: 2019-07-03 12:30:39 +0000

    virtual/{blas,cblas,lapack,lapacke}: add virtual packages.
    
      These virtual packages are used by the BLAS/LAPACK runtime switching
      mechanism.
    
    Closes: https://github.com/gentoo/gentoo/pull/12323
    Closes: https://bugs.gentoo.org/373613
    Closes: https://bugs.gentoo.org/381801
    Closes: https://bugs.gentoo.org/498490
    Closes: https://bugs.gentoo.org/563674
    Closes: https://bugs.gentoo.org/564546
    Closes: https://bugs.gentoo.org/565776
    Closes: https://bugs.gentoo.org/646316
    Closes: https://bugs.gentoo.org/657984
    Closes: https://bugs.gentoo.org/659014
    Closes: https://bugs.gentoo.org/659264
    Closes: https://bugs.gentoo.org/669644
    
    Signed-off-by: Mo Zhou <cdluminate@gmail.com>
    Signed-off-by: Benda Xu <heroxbd@gentoo.org>

 virtual/blas/blas-3.8.ebuild       | 14 ++++++++++++++
 virtual/blas/metadata.xml          | 10 +++++++---
 virtual/cblas/cblas-3.8.ebuild     | 14 ++++++++++++++
 virtual/cblas/metadata.xml         | 10 +++++++---
 virtual/lapack/lapack-3.8.ebuild   | 14 ++++++++++++++
 virtual/lapack/metadata.xml        | 10 +++++++---
 virtual/lapacke/lapacke-3.8.ebuild | 14 ++++++++++++++
 virtual/lapacke/metadata.xml       | 16 ++++++++++++++++
 8 files changed, 93 insertions(+), 9 deletions(-)